#!/usr/bin/perl

use Data::Dumper;

=head1

 aps: regraAt x pal-set -> pal-set

=cut

sub aps{
  my($r,@pal)=@_;
  my @r=();
  @r = map {if (/$r->[0]$r->[1]$/){ s/$r->[1]$/$r->[2]/i;$_ } 
            else {()};} @pal;
}

=head1

 ap: regra x pal-set -> pal-set

 regra = u(regra)   - d a primeira aplicao possivel
       | a(regra)   - d o conjunto de todas as aplicaes possiveis
       | c(regra)   - d a composio dos conjuntos
       | regraAt

=cut

sub ap{
  my($r,@pal)=@_;
  my @r=();
  if   (ref($r) eq "u"){
    @r = grep (/./, map { aps($_,@pal) } @$r);
    @r = (@r[0]);
  }
  elsif(ref($r) eq "a"){
    @r = map { ap($_,@pal) } @$r;
  }
  elsif(ref($r) eq "c"){
    @r=@pal;
    for(@$r){
      @r=grep(/./,ap($_,@r) );
    } 
  }
  else  {@r= ( aps($r,@pal))}
  @r;
}

sub prefixos{
  my($r,@pal)=@_;
  my @r=();
  if   (ref($r) eq "u"){
    @r = map { $_->[0].$_->[1] } @$r;
  }
  elsif(ref($r) eq "a"){
    @r = map { prefixos($_) } @$r;
  }
  elsif(ref($r) eq "c"){
    @r = prefixos($r->[0]) ;
  }
  else  {
    @r= ( $r->[0].$r->[1]  )
  }
  @r;
}

sub conc1{
  my($r1,$r2)=@_;
  my $p="$r1->[0]$r1->[1]";
  @t1=ap($r2,ap($r1,$p)); # =~ s/^$p/$r1->[1]/ ;
  map {print "$_\n";s/$r1->[0]// ; [$r1->[0], $r1->[1], $_] } @t1; 
}

sub conc2{
  my($r1,$r2)=@_;
  my $p="$r1->[0]$r1->[1]";
  @t1=ap($r2,ap($r1,$p)); # =~ s/^$p/$r1->[1]/ ;
  map {print "$_\n";s/$r1->[0]// ; [$r1->[0], $r1->[1], $_] } @t1; 
}

sub conc{
  my($r1,$r2)=@_;
  my $p=$r1->[1];
  [$r1->[0], $r1->[1],ap($r2,ap($r1,$p))];
}

# exemplos

$p=u(                    # plural
     ["","o","es"],
     ["r","","es"],
     ["","","s"],
    );

$pn=a(
     ["","",""],
     ["","","s"],
     ["","",""],
     ["","","mos"],
     ["","a","eis"],
     ["","e","eis"],
     ["i","","eis"],
     ["","","m"],
     );

$id=["","",""];                           # identidade

$f=u(["","o","a"],                        # feminino
     ["or","","a"],
     ["","o","ona"],
    );

$GN = a( $id,                             # genero numero
         $f,
         $p,
         c($f,$p)
       );

$pp=c(u(["","er","ido"],                  #participio passado
        ["","r","do"]), $GN);

$verbo=a(                                 #verbos
    c(u(                                    #imperfeito do indicativo
         ["a","r","va"],
         ["","er","ia"],
         ["i","r","a"]),
      $pn),
    c(["","r","sse"],                       #imperfeito do conjuntivo
      $pn),
    c(["r","","ia"],                        # condicional
      $pn),
    $pp);                                   # participio

$ppf=a( conc1($pp,$f) ,$pp);

sub u {bless([@_],"u");}
sub a {bless([@_],"a");}
sub c {bless([@_],"c");}

#print Dumper($GN);
#print join("...", ap($GN,"lindo"))," (GN(lindo))\n" ; 
#print join("...", ap($p,"lindo"))," (p(lindo))\n" ; 
#print join("...", ap($p,"leo"))," (p(leo))\n" ; 
#print join("...", ap($verbo,"lavar"))," (verbo(lavar))\n" ; 
print join("...",prefixos($verbo));

print "-" x 20, "\n";
while(<>){
  chop;
  print join("...", ap($verbo,$_))," (verbo($_))\n" ; 
}

__DATA__
